/* ****************************************************************************
                                      
      Filename:       AMUSAVE.cmd
                                                                            
      Project:         Backup utility for all AMU-Controller-Configurations-Files
                                                                           
      Description:
 
      Author:  

      History:        16. 08. 1999

      Version:        2.00
------------------------------------------------------------------
   
      (C) Copyright by ADIC Grau Storage System 1998,1999
                                                                            
****************************************************************************** */

'@echo off' ; cls
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

CALL ON ERROR NAME 10_1_ERROR_HANDLING
CALL ON HALT   NAME 10_2_BREAK_HANDLING

Act_Dir = Directory() ; Act_Drive = Left(Act_Dir,1) 

/* ************************************ */
Version = 2.00
/* ************************************ */

Software_Number = 7

Software.1 = 'OS/2-Config-Files'
File_Number.1 = 6
   file.1.1 = 'config.sys'
   file.1.2 = 'autoexec.bat'
   file.1.3 = 'startup.cmd'
   file.1.4 = 'popuplog.os2'
   file.1.5 = 'OS2\INSTALL\os2.ini'
   file.1.6 = 'OS2\INSTALL\os2sys.ini'
 

Software.2 = 'AMU-Config-Files'
File_Number.2 = 19
   file.2.1  = 'AMU\amuconf.ini'
   file.2.2  = 'AMU\amuconst.ini'
   file.2.3  = 'AMU\confamu.ini'
   file.2.4  = 'AMU\constamu.ini'
   file.2.5  = 'AMU\amuini.ini'
   file.2.6  = 'AMU\krna1err.ini'
   file.2.7  = 'AMU\k1to2.asc'
   file.2.8  = 'AMU\local.amu'
   file.2.9  = 'AMU\krnrefpt.r00'
   file.2.10 = 'AMU\krnrefpt.r01'
   file.2.11 = 'AMU\krnrefpt.r02'
   file.2.12 = 'AMU\backup.pmc'
   file.2.13 = 'AMU\pmaxconf.dat'
   file.2.14 = 'AMU\mvar.bak'
   file.2.15 = 'AMU\AMUStart.cmd'
   file.2.16 = 'AMU\RqmCom.txt'
   file.2.17 = 'AMU\ArtCfg.dat'
   file.2.18 = 'BALDOR\SOURCEN\mvar.pmc'
   file.2.19 = 'BALDOR\SOURCEN\dl.pmc'

Software.3 = 'DAS-Config-Files'
File_Number.3 = 2
   file.3.1 = 'DAS\ETC\config'
   file.3.2 = 'DAS\ETC\dasdata.ini'

Software.4 = 'TCPIP-Config-Files'
File_Number.4 = 9
   file.4.1 = 'TCPIP\BIN\tcpstart.cmd'
   file.4.2 = 'MPTN\protocol.ini'
   file.4.3 = 'MPTN\BIN\setup.cmd'
   file.4.4 = 'MPTN\ETC\HOSTS'
   file.4.5 = 'MPTN\ETC\TRUSERS'
   file.4.6 = 'MPTN\ETC\RESOLV2'
   file.4.7 = 'TCPIP\ETC\HOSTS'
   file.4.8 = 'TCPIP\ETC\TRUSERS'
   file.4.9 = 'TCPIP\ETC\RESOLV2'

Software.5 = 'Interface-Config-Files'
File_Number.5 = 4
   file.5.1 = 'IBMCOM\protocol.ini'
   file.5.2 = 'IBMCOM\lantran.log'
   file.5.3 = 'QCF\OS2EXE\qcomparm.prm'
   file.5.4 = 'QCF\OS2EXE\qparm.prm'

Software.6 = 'CM-Config-Files'
File_Number.6 = 0
   call 4_Search_Cmfile                       /* Search for the active and default Cmfile */
File_Number.6 = Number

Software.7 = 'More-Config-Files'
File_Number.7 = 5
   file.7.1 = 'KOPYKAT\KOPY.dat'
   file.7.2 = 'KOPYKAT\KAT.dat'
   file.7.3 = 'DCAF11\dcaf.ini'
   file.7.4 = 'DCAF13\dcaf.ini'
   file.7.5 = 'ATLS32\atls32.ini'

/* ************************************ */

Syslevel_Check_File_Number = 9
   Syslevel_Check_file.1 = 'TCPIP\BIN\ftpd.exe'
   Syslevel_Check_file.2 = 'TCPIP\BIN\ftpdc.exe'
   Syslevel_Check_file.3 = 'TCPIP\BIN\ftpdtrc.exe'
   Syslevel_Check_file.4 = 'TCPIP\BIN\nr2.exe'
   Syslevel_Check_file.5 = 'TCPIP\BIN\tcpcoex.exe'
   Syslevel_Check_file.6 = 'TCPIP\DLL\TCPUNX.DLL'
   Syslevel_Check_file.7 = 'TCPIP\DLL\tnls16.dll'
   Syslevel_Check_file.8 = 'TCPIP\DLL\tnls32.dll'
   Syslevel_Check_file.9 = 'TCPIP\DLL\setloc1.dll'
 
/* ************************************ */
   
   Y_Coord = 2 ; X_Coord = 2 ; Save_Number = 0 ; Size_Save = 0 ; Size_Free = true
   Space_Line = Copies(" ",69) ; Mark_Line = '   '||Copies("_",60) ; Path_Number = 0
   Sub_D_Exist = 0 ; C_AmuSave_Exist = 0 ; C_Save_0_Exist = 0 ; C_Save_1_Exist = 0
   D_Save_0_Exist = 0 ; D_Save_1_Exist = 0 ; D_AmuSave_Exist = 0
   Pkzip_amu_Exist = 0 ; Pkzip_amusave_Exist = 0 ; Pkzip_a_Exist = 0
   A_Save_0_Exist = 0 ; A_Save_1_Exist = 0 ; Print_Number = 0
   AMU_Version = "-----" ; DAS_Version = "-----" ; KAT_Version = "-----"
   Entry = false ; ERROR_Bit = false ; AMU_Name = 'AMU'
      
/* ************************************* */
   
   call SysCls
   call SysCurPos 1,0
   say " Ŀ"
   say "                        B A C K U P     U T I L I T Y           (Ver. "Version")  "
   say "                        (valid from AML-Version 2.20)                        "
   say "                                                                             "
   say "                                                                             "
   say "    All important configuration-files will be saved from the AML-Controller  "
   say "    to different targets :                                                   "
   say "                                                                             "
   say "   1 = The files will be saved on floppy         'A:\save_0'.                "
   say "                                                                             "
   say "   2 = The files will be saved to the directory  'C:\amusave\save_0'.        "
   say "                                                                             "
   say "   3 = The files will be saved to the directory  'D:\amusave\save_0'.        "
   say "       Additionally the orginal files will be updated on the harddisk 'D:'.  "
   say "                                                                             "
   say "   4 = Exit without save.                                                    "
   say "                                                                             "
   say "                                                                             "
   say "    If in the directory 'C:\amusave\save_0' or on the floppy 'A:\save_0'     "
   say "    an older backup already exists then these files will be loaded into the  "
   say "    new directory '...\save_1'.                                              "
   say "                                                                             "
   say "  Select an Option:                                                          "
   say " "
  
   Do D = 1 to 3
      call SysCurPos 22,22 ; Option = translate(SysGetKey('NOECHO'))

      If Option = "1" then 
         Do
            say '1' ; Entry = true ; Save_A = 1
         End

      If Option = "2" then 
         Do
            say '2' ; Entry = true ; Save_C = 1
         End

      If Option = "3" then
         Do
            say '3' ; Entry = true ; Save_D = 1
         End

      If Option = "4" then
         Do
            Call SysCls ; exit
         End
 
      If Entry = true then
         Do
            Call SysCurPos 24,2 ; say ; say
            Call 1_Query_Check
            Call 1_1_File_Search
            Call 2_Prepare_Check ; Call SysSleep(3)
            Call 3_File_List
            
            Call SysCurPos 24,2 ; say ; say
            Call SysCurPos 24,2 ; say 'INFO:    The backup-file(s) was successfully copied'
            Call SysCurPos 24,2 ; say ; say
            Search_file = 'C:\amu\krnrefpt.R01' ; Call 6_2_Search_file
            If Exist = 1 then
               Do
                  say ; Call SysCurPos 24,2 ; say 'ATTENTION:   Do not forget to save the robot and tower configuration-files'
               End
            If AMU_Name = 'A01' | AMU_Name = 'A02' then
               Do
                  say ; Call SysCurPos 24,2 ; say 'ATTENTION:   Do not forget to save the second controller (Master / Backup PC)'
                  Call SysCurPos 24,2 ; say '             on a separate Disk'
               End
            say ; say ; say
            exit
         End
   End D

   Call SysCls ; say ; say ; say
   say 'WARNING: BACKUP UTILITY ENDING!'
   say '         Sorry, but you need to make up your mind!'

EXIT

/******************************************************************** */

/**************************************/
1_Query_Check:
/**************************************/

   If Save_A = 1 then
      Do
         Call SysCurPos 24,2 ; say "INFO:    Search directory  'A:\SAVE_0' " ; say
            Search_Sub = 'A:\SAVE_0' ; Call 6_1_Search_Dir ; A_Save_0_Exist = Exist
            Call SysCurPos 22,55
            If A_Save_0_Exist = 1 then say  '  --->  found' ; else ; say '  --->  not found'
            If A_Save_0_Exist = 1 then Call 9_Open_Window_Check

         Call SysCurPos 24,2 ; say "INFO:    Search directory  'A:\SAVE_1' " ; say
            Search_Sub = 'A:\SAVE_1' ; Call 6_1_Search_Dir ; A_save_1_Exist = Exist
            Call SysCurPos 22,55
            If A_Save_1_Exist = 1 then say  '  --->  found' ; else ; say '  --->  not found'
            If A_Save_1_Exist = 1 then Call 9_Open_Window_Check
      End
 
   If Save_C = 1 then
      Do
         Call SysCurPos 24,2 ; say "INFO:    Search directory  'C:\amusave' " ; say
            Search_Sub = 'C:\amusave' ; Call 6_1_Search_Dir ; C_AmuSave_Exist = Exist
            Call SysCurPos 22,55
            If C_AmuSave_Exist = 1 then say  '  --->  found' ; else ; say '  --->  not found'

         Call SysCurPos 24,2 ; say "INFO:    Search directory  'C:\amusave\save_0' " ; say
            Search_Sub = 'C:\amusave\save_0' ; Call 6_1_Search_Dir ; C_Save_0_Exist = Exist
            Call SysCurPos 22,55
            If C_Save_0_Exist = 1 then say  '  --->  found' ; else ; say '  --->  not found'
            If C_Save_0_Exist = 1 then Call 9_Open_Window_Check

         Call SysCurPos 24,2 ; say "INFO:    Search directory  'C:\amusave\save_1' " ; say
            Search_Sub = 'C:\amusave\save_1' ; Call 6_1_Search_Dir ; C_Save_1_Exist = Exist
            call SysCurPos 22,55
            If C_Save_1_Exist = 1 then say  '  --->  found' ; else ; say '  --->  not found'
            If C_Save_1_Exist = 1 then Call 9_Open_Window_Check
      End

   If Save_D = 1 then
      Do
         Call SysCurPos 24,2 ; say "INFO:    Search Harddisk   'D:' with OS/2 System" ; say
         Drive_D = SysDriveInfo('D:') ; parse value Drive_D with . D_Info .
         If D_Info = "" then Sub_D_Exist = 0
         If D_Info <> "" then
            Do
               Search_Sub = 'D:\OS2' ; Call 6_1_Search_Dir ; Sub_D_Exist = Exist
            End
         Call SysCurPos 22,55 ; If Sub_D_Exist = 1 then say  '  --->  found' ; else ; say '  --->  not found'
         If Sub_D_Exist = 0 then
            Do
               call SysCurPos 24,2 ; say "INFO:    The program will be closed !" ; say ; say
               Exit
            End
      
         Call SysCurPos 24,2 ; say "INFO:    Search directory  'D:\amusave' " ; say
            Search_Sub = 'D:\amusave' ; Call 6_1_Search_Dir ; D_AmuSave_Exist = Exist
            Call SysCurPos 22,55
            If D_AmuSave_Exist = 1 then say  '  --->  found' ; else ; say '  --->  not found'

         Call SysCurPos 24,2 ; say "INFO:    Search directory  'D:\amusave\save_0' " ; say
            Search_Sub = 'D:\amusave\save_0' ; Call 6_1_Search_Dir ; D_Save_0_Exist = Exist
            Call SysCurPos 22,55
            If D_Save_0_Exist = 1 then say  '  --->  found' ; else ; say '  --->  not found'
            If D_Save_0_Exist = 1 then Call 9_Open_Window_Check

         Call SysCurPos 24,2 ; say "INFO:    Search directory  'D:\amusave\save_1' " ; say
            Search_Sub = 'D:\amusave\save_1' ; Call 6_1_Search_Dir ; D_Save_1_Exist = Exist
            call SysCurPos 22,55
            If D_Save_1_Exist = 1 then say  '  --->  found' ; else ; say '  --->  not found'
            If D_Save_1_Exist = 1 then Call 9_Open_Window_Check
      End
   
Return

/**************************************/
1_1_File_Search:
/**************************************/

   Size_Save = 10000 ; Drive_free = 0
   Call SysCurPos 24,2 ; say "INFO:    Search and check all configuration files " ; say

   Do i = 1 to Software_Number
      Do j = 1 to File_Number.i
         M1 = stream('C:\'file.i.j, 'c', 'query exists')
         If M1 \= "" then 
            Do
               file_exist.i.j = 1 ; Size1 = stream('C:\'file.i.j, 'c', 'query size')
               Size2 = (Trunc(Size1/512) +1)*512 ; Size_Save = Size_Save + Size2
            End
         else
            Do
               file_exist.i.j = 0
            End
      End j
   End i

   Search_Sub = 'C:\das' ; Call 6_1_Search_Dir
      If Exist = 1 then 
         Do
            file_exist.3.2 = 1 ; Size_Save = Size_Save + 1024
         End

   Call 6_3_Search_Save_Dir ; Size_Save = Size_Save + ((Path_Number +1) * 512)

   If Save_A = 1 then
      Do
         If A_Save_1_Exist = 1 then
            Do
               Del_Sub = 'A:\save_1\' ; Call 5_Del_Sub_Dir ; Call SysRmDir('A:\save_1')
               File = 'A:\SAVE_1.TXT' ; DEL File ' > NUL' ; A_Save_1_Exist = 0
            End
         Drive_info = sysdriveinfo('a:') ; parse value drive_info with . Drive_free .
         If Drive_free < Size_Save then
            Do
               Size_Free = false 
               If A_Save_0_Exist = 1 then Call 7_Pkzip_Handling
               If A_Save_0_Exist = 0 then
                  Do
                     say
                     Call SysCurPos 24,2 ; say "INFO:    There is not enough space on the disk !"
                     Call SysCurPos 24,2 ; say "         Free space   : " drive_free " bytes"
                     Call SysCurPos 24,2 ; say "         Required space : " Size_Save " bytes"
                     Call SysCurPos 24,2 ; say ""
                     Call SysCurPos 24,2 ; say "INFO:    The program will be closed !" ; say ; say
                     Error_Help = SysGetMessage(0112 , OSO001H.msg)
                     say ; say Error_Help ; say ; say
                     exit
                  End
            End
      End
  
Return

/**************************************/
2_Prepare_Check:
/**************************************/

   If Save_A = 1 then
      Do
         If A_Save_0_Exist = 0 then
            Do
               Call SysCurPos 24,2 ; say "INFO:    Create new directory   --->   'A:\save_0' " ; say
               Call SysMkDir 'A:\save_0' ; A_Save_0_Exist = 2
            End
         If A_Save_0_Exist = 1 then
            Do
               Call SysCurPos 24,2 ; say "INFO:    Rename old directory   --->   'A:\save_1' " ; say
               Call SysCurPos 24,2 ; say "INFO:    Rename old Backup-List --->   'A:\save_1.txt' " ; say
               ren 'A:\save_0 save_1 > NUL'
               File = 'A:\save_0.txt' ; ren File ' save_1.txt > NUL'
               Call SysMkDir 'A:\save_0' ; A_Save_0_Exist = 2
            End
      End

   If Save_C = 1 then
      Do
         If C_AmuSave_Exist = 0 then
            Do
               Call SysCurPos 24,2 ; say "INFO:    Create new directory   --->   'C:\amusave' " ; say
               Call SysMkDir 'C:\amusave'
            End
         If C_Save_0_Exist = 0 then
            Do
               Call SysCurPos 24,2 ; say "INFO:    Create new directory   --->   'C:\amusave\save_0' " ; say
               Call SysMkDir 'C:\amusave\save_0'
            End
         If C_Save_1_Exist = 1 then
            Do
               Del_Sub = 'C:\amusave\save_1\' ; Call 5_Del_Sub_Dir ; Call SysRmDir('C:\amusave\save_1')
               File = 'C:\amusave\save_1.txt' ; DEL File ' > NUL'
            End
         If C_Save_0_Exist = 1 then
            Do
               Call SysCurPos 24,2 ; say "INFO:    Rename old directory   --->   'C:\amusave\save_1' " ; say
               Call SysCurPos 24,2 ; say "INFO:    Rename old Backup-List --->   'C:\amusave\save_1.txt' " ; say
               ren 'C:\amusave\save_0 save_1 > NUL'
               File = 'C:\amusave\save_0.txt' ; ren File ' save_1.txt > NUL'
               Call SysMkDir 'C:\amusave\save_0'
            End
      End
     
  If Save_D = 1 then
      Do
         If D_AmuSave_Exist = 0 then
            Do
               Call SysCurPos 24,2 ; say "INFO:    Create new directory   --->   'D:\amusave' " ; say
               Call SysMkDir 'D:\amusave'
            End
         If D_Save_0_Exist = 0 then
            Do
               Call SysCurPos 24,2 ; say "INFO:    Create new directory   --->   'D:\amusave\save_0' " ; say
               Call SysMkDir 'D:\amusave\save_0'
            End
         If D_Save_1_Exist = 1 then
            Do
               Del_Sub = 'D:\amusave\save_1\' ; Call 5_Del_Sub_Dir ; Call SysRmDir('D:\amusave\save_1')
               File = 'D:\amusave\save_1.txt' ; DEL File ' > NUL'
            End
         If D_Save_0_Exist = 1 then
            Do
               Call SysCurPos 24,2 ; say "INFO:    Rename old directory   --->   'D:\amusave\save_1' " ; say
               Call SysCurPos 24,2 ; say "INFO:    Rename old Backup-List --->   'D:\amusave\save_1.txt' " ; say
               ren 'D:\amusave\save_0 save_1 > NUL'
               File = 'D:\amusave\save_0.txt' ; ren File ' save_1.txt > NUL'
               Call SysMkDir 'D:\amusave\save_0'
            End
      End

Return

/**************************************/
3_File_List:
/**************************************/

   Call 3_1_Mask
   Call 3_2_File_Eject
   Call 3_3_File_Save
   
   Do M = 1 to 5 ; Call SysCurPos 17 + M , 0 ; say Space_Line ; End M

   If Save_A = 1 then
      Do
         Backup_Path = 'A:\SAVE_0' ; Call 8_2_Syslevel_List ; Call 8_1_Dir_List
         If CM_Default_Dif = 1 then COPY 'C:\cmlib\cmquery.txt A:\save_0\cmlib\cmquery.txt > NUL'
         If file_exist.3.2 = 1 then ATTRIB 'A:\save_0\DAS\ETC\dasdata.ini -h -r -s > NUL'
         label 'A:backup_ 'AMU_Name
      End

   If Save_C = 1 then
      Do
         Backup_Path = 'C:\amusave\save_0' ; Call 8_2_Syslevel_List ; Call 8_1_Dir_List
         If CM_Default_Dif = 1 then COPY 'C:\cmlib\cmquery.txt C:\amusave\save_0\cmlib\cmquery.txt > NUL'
         If file_exist.3.2 = 1 then ATTRIB 'C:\amusave\save_0\DAS\ETC\dasdata.ini -h -r -s > NUL'
      End
      
   If Save_D = 1 then
      Do
         Backup_Path = 'D:\amusave\save_0' ; Call 8_2_Syslevel_List ; Call 8_1_Dir_List
         If CM_Default_Dif = 1 then COPY 'C:\cmlib\cmquery.txt D:\amusave\save_0\cmlib\cmquery.txt > NUL'
         If file_exist.3.2 = 1 then ATTRIB 'D:\amusave\save_0\DAS\ETC\dasdata.ini -h -r -s > NUL'
      End

Return
    
/**************************************/
3_1_Mask:
/**************************************/
 
   Call SysCls
   STR1 = ''COPIES('',76)'' ; STR2 = ''COPIES('',76)'' ; STR3 = ''copies(' ',76)''
   Call SysCurPos 2,1 ; say STR1
   Do M = 3 to 16 ; Call SysCurPos M,1 ; say STR3 ; End  
   Call SysCurPos 17,1 ; say STR2

Return

/**************************************/
3_2_File_Eject:
/**************************************/

   Do i=1 to Software_Number
      Call 3_4_Table_Calculation ; Found = 0 ; Print_Number = Print_Number + 1
      If Print_Number < 42 then say '('i')'Software.i
         
      Do j=1 to File_Number.i
         If file_exist.i.j = 1 then
            Do
               Save_Number = Save_Number + 1 ; Found = 1 ; Print_Number = Print_Number + 1
               Call 3_4_Table_Calculation
               If Print_Number < 42 then
                  Do
                     file_name = filespec("name", file.i.j) ; say '     'file_name
                  End
               File1.Save_Number = file.i.j
               Pos1.Save_Number.1 = Y_Coord ; Pos1.Save_Number.2 = X_Coord + 3
            End
      End j
      If Found = 0 then
         Do
            Call 3_4_Table_Calculation ; Print_Number = Print_Number + 1
            If Print_Number < 42 then say '     ! No files found !'
         End
   End i
   Call SysCurPos 1,1 ; say 'Following config-files are found:'
   Call SysCurPos 1,35 ; say Save_Number' file(s) with'
   Call SysCurPos 1,52 ; say Size_Save' bytes'
   If Save_A = 1 then
      Do
         Call SysCurPos 1,66 ; say '('Drive_free' free)'
      End
   Call SysCurPos 20,1 ; say 'source :' ; Call SysCurPos 22,1 ; say 'target :'

Return

/**************************************/
3_3_File_Save:
/**************************************/

   Do k = 1 to Save_Number
      pos = lastpos('\',file1.k) ; ERROR_Bit = false
      If pos > 0 then file = DELSTR(file1.k,pos+1) ; else ; file = ''
      Call SysCurPos Pos1.K.1 , Pos1.K.2 - 3 ; say Left('   * 'filespec("name", File1.k), 24)
      Call SysCurPos 17,0

      If Save_A = 1 & A_Save_0_Exist > 1 then
         Do
            Call SysCurPos 20,11 ; say Space_Line ; Call SysCurPos 22,10 ; say Space_Line
            Call SysCurPos 20,11 ; say 'C:\'File1.K
            Call SysCurPos 22,11 ; say 'A:\save_0\'File1.K
            Call SysCurPos 18,0
            xcopy 'C:\'file1.k 'A:\save_0\'file'/V/T > NUL'
         End

      If Save_C = 1 then
         Do
            Call SysCurPos 20,11 ; say Space_Line ; Call SysCurPos 22,10 ; say Space_Line
            Call SysCurPos 20,11 ; say 'C:\'File1.K
            Call SysCurPos 22,11 ; say 'C:\amusave\save_0\'File1.K
            Call SysCurPos 18,0
            xcopy 'C:\'file1.k 'C:\amusave\save_0\'file'/V/T > NUL'
         End

      If Save_D = 1 & Sub_D_Exist = 1 then
         Do
            Call SysCurPos 20,11 ; say Space_Line ; Call SysCurPos 22,10 ; say Space_Line
            Call SysCurPos 20,11 ; say 'C:\'File1.K
            Call SysCurPos 22,11 ; say 'D:\'File1.K
            Call SysCurPos 18,0
            xcopy 'C:\'file1.k 'D:\'file'/V/T > NUL'
            Call SysCurPos 20,11 ; say 'D:\'File1.K
            Call SysCurPos 22,11 ; say 'D:\amusave\save_0\'File1.K
            Call SysCurPos 18,1
            xcopy 'C:\'file1.k 'D:\amusave\save_0\'file'/V/T > NUL'
         End

      If ERROR_Bit = true then
         Do
            ERROR_Bit = false ; Call SysCurPos Pos1.K.1 , Pos1.K.2 - 3 ; say Left('   - 'filespec("name", File1.k), 24)
         End
   End

Return

/**************************************/
3_4_Table_Calculation:
/**************************************/
 
   Y_Coord = Y_Coord + 1
   If Y_Coord = 17 then
      Do
         Y_Coord = 3 ; X_Coord = X_Coord + 26
         If X_Coord > 79 then X_Coord = 2
      End
   Call SysCurPos Y_Coord , X_Coord

Return

/**************************************/
4_Search_Cmfile:
/**************************************/

   Number = 0 ; CM_Exist = stream('C:\cmlib\cmquery.exe', 'c', 'query exists')
   If CM_Exist <> "" then
      Do
         'C:\cmlib\'cmquery '> C:\cmlib\cmquery.txt'
         Do A = 1 to 10          
            CM.A = linein('C:\cmlib\cmquery.txt') ; parse value CM.A with CM.A.1 CM.A.2 CM.A.3 CM.A.4
            If CM.A.1 = 'Workstation' then CM_Workstation_Type = CM.A.4
            If CM.A.1 = 'Default' then CM_Default = CM.A.4
            If CM.A.1 = 'Active' then CM_Active = CM.A.4
         End A
         Call lineout 'C:\cmlib\cmquery.txt'

         If CM_Workstation_Type = "Access Feature" then
            Do
               CM_Personal_Path = 'C:\' ; NewDir = Directory("C:\")
               Call SysFileTree 'PCOMOS2\PRIVATE', 'file', 'DS'
                  Do I = 1 to file.0
                     parse upper value file.I with . . . . Sub.I
                     If Left(Space(Sub.I), 10) \= 'C:\AMUSAVE' then CM_Personal_Path  = Space(Overlay('    ', Sub.I))||'\'
                  End I
               NewDir = Directory(Act_Dir)
            End

         CM_SET = CM_Default ; Call 4_1_CM_File_Query
         If Space(CM_Default) <> Space(CM_Active) & CM_Active \= "" then 
            Do
               CM_Default_Dif = 1 ; CM_SET = CM_Active ; Call 4_1_CM_File_Query
            End
      End

Return

/**************************************/
4_1_CM_File_Query:
/**************************************/

   Number = Number + 1 ; file.6.Number = 'CMLIB\'Space(CM_SET)'.cfg'
   Number = Number + 1 ; file.6.Number = 'CMLIB\'Space(CM_SET)'.cf1'
   Number = Number + 1 ; file.6.Number = 'CMLIB\'Space(CM_SET)'.ndf'
   Number = Number + 1 ; file.6.Number = 'CMLIB\'Space(CM_SET)'.sec '
   Number = Number + 1 ; file.6.Number = 'CMLIB\'Space(CM_SET)'.emr'
   Number = Number + 1 ; file.6.Number = 'CMLIB\'Space(CM_SET)'.rsp'
   
   If CM_Workstation_Type = "Access Feature" then
      Do
         EXE.1 = 'bch' ; EXE.2 = 'rsp' ; EXE.3 = 'ws'
         Do A = 1 to 3
            Call SysFileTree 'C:\'||CM_Personal_Path||'*.'||EXE.A, 'file', 'F'
               Do I = 1 to file.0
                  Number = Number + 1 ; parse upper value file.I with . . . . CM_file
                  file.6.Number = Space(Overlay('    ', CM_file))
               End I
         End A
      End

Return

/**************************************/
5_Del_Sub_Dir:
/**************************************/

   Call SysFileTree Del_Sub, 'file', 'FS'
      Do I = 1 to file.0
         parse value file.I with . . . . sub.I ; sub_F.I = Space(sub.I)
         DEL sub_F.I '2>NUL'
      End I
   Call SysFileTree Del_Sub, 'file', 'DS'
      Do I = 1 to file.0
         parse value file.I with . . . . sub.I ; sub_D.I = Space(sub.I)
      End I
      Sub_Dir = I - 1
      Do J = Sub_Dir by -1 to 1
         rc = SysRmDir(sub_D.J)
      End J
   
Return

/**************************************/
6_1_Search_Dir:
/**************************************/
 
   Exist = 0 ; Sub_D = '' ; rc = 2
   rc = SysFileTree(Search_Sub, 'file', 'D')
   If rc = 0 then
      Do I = 1 to file.0
         parse upper value file.I with . . . . Sub.I ; Sub_D = Space(Sub.I)
      End I
   parse upper value Search_Sub with Search_Sub_large
   If Sub_D = Search_Sub_large then Exist = 1

Return

/**************************************/
6_2_Search_File:
/**************************************/

   Exist = 0 ; S_files = ' '
   rc = SysFileTree(Search_file, 'file', 'F')
   If rc = 0 then
      Do
         Do I = 1 to file.0
            parse upper value file.I with . . . . files.I ; S_files = Space(files.I)
         End I
         parse upper value Search_file with Search_file_large
         If S_files = Search_file_large then Exist = 1 
      End

Return

/**************************************/
6_3_Search_Save_Dir:
/**************************************/

   Path_Number = 0 ; Path_String = ""
   Do I=1 to Software_Number
      Do J=1 to File_Number.i
         If file_exist.I.J = 1 then
            Do
               Path = filespec("path", file.I.J)
               If Path > '' then
                  Do
                     Length_Path = Length(Path) ; Path_String = DELSTR(Path, Length_Path) ; Call 6_3_1_Search_Save_Dir
                  End
                  Do while Length_Path <> 0
                     Length_Path = LASTPOS('\' , Path_String)
                     If Length_Path > 0 then
                        Do
                           Path = LEFT(Path_String , Length_Path)
                           Path_String = DELSTR(Path_String, Length(Path_String)-Length_Path+1)
                           Call 6_3_1_Search_Save_Dir
                        End
                  End
            End
      End J
   End I

Return

/**************************************/
6_3_1_Search_Save_Dir:
/**************************************/

   Do k = 1 to Path_Number
      If Path = Path_entry.k then Path = ""
   End k
   If Path <> "" then 
      Do
         Path_Number = Path_Number +1 ; Path_entry.k = Path
      End

Return

/**************************************/
7_Pkzip_Handling:
/**************************************/

   Search_file = 'C:\amusave\PKZIP2.EXE' ; Call 6_2_Search_file ; Pkzip_amusave_Exist = Exist
   Search_file = 'C:\amu\pkzip2.exe' ; Call 6_2_Search_file ; Pkzip_amu_Exist = Exist
   Search_file = 'A:\PKZIP2.EXE' ; Call 6_2_Search_file ; Pkzip_a_Exist = Exist
   If Pkzip_amusave_Exist = 1 then Pkzip_Dir = "C:\amusave\PKZIP2.EXE"
   If Pkzip_amu_Exist = 1 then Pkzip_Dir = "C:\amu\PKZIP2.EXE"
   If Pkzip_a_Exist = 1 then Pkzip_Dir = "A:\PKZIP2.EXE"

   If Pkzip_amusave_Exist = 1 | Pkzip_amu_Exist = 1 | Pkzip_a_Exist = 1 then
      Do
         Call SysCurPos 24,2 ; say "INFO:    Rename old directory   --->   'A:\save_1' " ; say
         Call SysCurPos 24,2 ; say "INFO:    Rename old Backup-List --->   'A:\save_1.txt' " ; say
         ren 'A:\save_0 save_1 > NUL'
         File = 'A:\save_0.txt' ; ren File ' save_1.txt > NUL'
         Call SysMkDir 'A:\save_0' ; A_Save_0_Exist = 2
         Call 7_1_Zip_File ; Call 1_1_File_Search
      End

      If Pkzip_amusave_Exist = 0 & Pkzip_amu_Exist = 0 & Pkzip_a_Exist = 0 then
         Do
            say
            Call SysCurPos 24,2 ; say "INFO:    A backup already exists on the floppy and the free space is"
            Call SysCurPos 24,2 ; say "         not enough !"
            Call SysCurPos 24,2 ; say "         Because the program PKZIP2.EXE does not exist in the subdirectory"
            Call SysCurPos 24,2 ; say "         'C:\amu' or 'C:\amusave' or on the floppy, the actual backup-file"
            Call SysCurPos 24,2 ; say "         cannot be saved !"
            Call SysCurPos 24,2 ; say "         If you want to save the previous backup, please stop the program"
            Call SysCurPos 24,2 ; say "         and use a new empty floppy or copy the program PKZIP2.EXE in the"
            Call SysCurPos 24,2 ; say "         subdirectory 'C:\amu' or 'C:\amusave'."
            Call SysCurPos 24,2 ; say "         If you select (Y), the actual backup will be overwritten."
            Call SysCurPos 24,2 ; say " "
            Call SysCurPos 24,2 ; say "         Do you want to overwrite the actual backup ?  (Y/N)" 
            say ; say
            Do while Input <> "Y" & Input <> "N"
               call SysCurPos 21,64 ; Input = translate(SysGetKey('NOECHO'))
               call SysCurPos 21,64 ; say Input
            End

            If Input = 'Y' | Input = "y" then
               Do
                  Del_Sub = 'A:\save_0\' ; Call 5_Del_Sub_Dir ; Call SysRmDir('A:\save_0')
                  File = 'A:\SAVE_0.TXT' ; DEL File ' > NUL'
                  Call SysMkDir 'A:\save_0' ; A_Save_0_Exist = 2
                  Call 1_1_File_Search
               End
            If Input = 'N' | Input = "n" then
               Do
                  Call SysCurPos 24,2 ; say "INFO:    The program will be closed !" ; say ; say
                  Exit
               End
         End

Return

/**************************************/
7_1_Zip_File:
/**************************************/
   
   Call SysCurPos 24,2 ; say "INFO:    Create Backup-Zip-file from :"
   Call SysCurPos 24,22 ; say "A:\save_1   --->    'A:\save_1\save_old.zip'" ; say
   Pkzip_Dir '-b -a -p -r A:\save_1.zip A:\save_1\*.* > NUL'
   Del_Sub = 'A:\save_1\' ; Call 5_Del_Sub_Dir
   move 'A:\save_1.zip \save_1\save_1.zip > NUL'
   
Return

/**************************************/
8_1_Dir_List:
/**************************************/

   File_List = Backup_Path||'.txt'
   Call SysCurPos 22,2 ; say "INFO:    Create Backup-List     --->  '"File_List"'" ; say

   Search_file = File_List  ; Call 6_2_Search_file ; IF Exist = 1 then DEL File_List' > NUL'
   Search_file = 'C:\AMU\Local.AMU' ; Call 6_2_Search_file ; IF Exist = 1 then AMU_Name = LineIn('C:\AMU\Local.AMU')
   Date_Line = 'from :     Date  '||translate(date(european) , '.' , '/')||'     Time  '||time(normal)

   Call LineOut File_List , Space_Line ; Call LineOut File_List , '                    BACKUP - LIST  of  Controller  'AMU_Name' :'
   Call LineOut File_List,'                      (written by Amusave-Version '||Version||')'
   Call LineOut File_List
   
   vol 'C: >> 'File_List
   Call LineOut File_List , Space_Line ; Call LineOut File_List , Date_Line
   Call LineOut File_List , Space_Line ; Call LineOut File_List , Space_Line

   Call SysFileTree Backup_Path'\*.*' , 'file', 'FS'
      Do I = 1 to file.0
         parse value file.I with Date.I Time.I Size.I . Files.I

         Files1 = "C:"||SPACE(overlay(Copies(' ' , Length(Backup_Path) + 1) , Files.I)) ; Files = Left(Files1,40)

         D1 = POS('/' , Date.I) ; Date2 = SUBSTR(Date.I ,1, D1-1) ; IF Length(Date2) = 1 then Date2 = "0"||Date2
         Date1 = SUBSTR(Date.I , D1 + 1 , 2) ; Date3 = SUBSTR(Date.I , D1 + 4 , 2)
         Dates = Left(Date1||'.'||Date2||'.'||Date3 , 12)
         
         Length_Time = Length(Time.I) ; T1 = SUBSTR(Time.I , Length_Time)
         T2 = POS(':' , Time.I) ; Time1 = SUBSTR(Time.I , 1 , T2 - 1) ; IF Length_Time = 5 then Time1 = ' '||Time1
         IF T1 = 'p' then Time1 = Time1 + 12
         Time2 = SUBSTR(Time.I , T2 + 1 , 2) ; Times = Left(Time1||'.'||Time2 , 7)

         Length_Size = Length(Size.I) ; Sizes = Left(Copies(' ',10-Length_Size)||Size.I , 15)

         Number_Size = Length(I) ; If Number_Size = 1 then Number = ' '||I||'. ' ; else ; Number = I||'. '

         Line = Number||Files||Sizes||Dates||Times
         Call LineOut File_List , Line
      End I

Return

/**************************************/
8_2_Syslevel_List:
/**************************************/

   Call SysCurPos 19,2 ; say 'INFO:    Create syslevel (software levels of the system)'
   Syslevel_List_File = Backup_Path||'\syslevel.txt'
   Call SysCurPos 20,29 ; say "     --->  '"Syslevel_List_File"'"

   SysLevel_Date = '            Syslevel from :      Date  '||translate(date(european) , '.' , '/')||'     Time  '||time(normal)
   If (Stream('C:\amu\showini.exe', 'c', 'query exists') \= "") & (Stream('C:\amu\amuconf.ini', 'c', 'query exists') \= "") then
      Do
         NewDir = Directory("C:\amu")
         'c:\amu\'showini 'proc version > 'Syslevel_List_File
         NewDir = Directory(Act_Dir)
         Do A = 1 to 4 ; String = LineIn(Syslevel_List_File) ; End
         AMU_String = LineIn(Syslevel_List_File) ; parse value AMU_String with . . AMU_Version
      End
   Else
      AMU_Version = "-->  The programm AMU doesn't exist !"

   If Stream('C:\DAS\BIN\DAS2.exe', 'c', 'query exists') \= "" then
      Do
         Syslevel_Check_File = 'C:\DAS\BIN\DAS2.EXE' ; Call 8_2_1_Syslevel_List_Query ; DAS_Line = File_Line ; DAS_Version = "unknown"
         If Dates = "23.08.96" then DAS_Version = "1.30B7"
         If Dates = "11.10.96" then DAS_Version = "1.30C "
         If Dates = "30.04.97" then DAS_Version = "1.30C3"
         If Dates = "20.10.97" then DAS_Version = "1.30C7"
         If Dates = "02.12.97" then DAS_Version = "1.30C8"
         If Dates = "27.05.98" then DAS_Version = "1.30C9"
         If Dates = "22.06.98" then DAS_Version = "1.30C10"
         If Dates = "07.06.99" then DAS_Version = "3.01"
      End
   Else
      DAS_Line = "-->  The programm DAS doesn't exist !"
 
If (Stream('C:\KOPYKAT\KAT.EXE', 'c', 'query exists') \= "") then
      Do
         Syslevel_Check_File = 'C:\KOPYKAT\KAT.EXE' ; Call 8_2_1_Syslevel_List_Query ; Kat_Line = File_Line ; Kat_Version = "unknown"
         If Dates = "16.05.95" then Kat_Version = "1.11"
         If Dates = "16.11.95" then Kat_Version = "1.20"
         If Dates = "18.03.96" then Kat_Version = "1.21"
      End
   Else
      Kat_Line = "-->  The programm Kat.exe doesn't exist !"

If (Stream('C:\KOPYKAT\KOPY.EXE', 'c', 'query exists') \= "") then
      Do
         Syslevel_Check_File = 'C:\KOPYKAT\KOPY.EXE' ; Call 8_2_1_Syslevel_List_Query ; Kopy_Line = File_Line ; Kat_Version = "unknown"
         If Dates = "16.05.95" then Kat_Version = "1.11"
         If Dates = "16.11.95" then Kat_Version = "1.20"
         If Dates = "18.03.96" then Kat_Version = "1.21"
      End
   Else
      Kopy_Line = "-->  The programm Kopy.exe doesn't exist !"

   Call LineOut Syslevel_List_File , '      '||Mark_Line , 1 ; Call LineOut Syslevel_List_File , ' '
   Call LineOut Syslevel_List_File , SysLevel_Date ; Call LineOut Syslevel_List_File , ' '
   Call LineOut Syslevel_List_File ,'                      (written by  Amusave-Version '||Version||')'
   Call LineOut Syslevel_List_File , '      '||Mark_Line
   Call LineOut Syslevel_List_File , ' ' ; Call LineOut Syslevel_List_File , ' '
   Call LineOut Syslevel_List_File , 'AMU-Version :       'AMU_Version ; Call LineOut Syslevel_List_File , ' '
   Call LineOut Syslevel_List_File , 'DAS-Version :       'DAS_Version '      ('Space(DAS_Line)')' ; Call LineOut Syslevel_List_File , ' '
   Call LineOut Syslevel_List_File , 'KopyKat-Version :   'Kat_Version '       ('Space(Kat_Line)')'
   Call LineOut Syslevel_List_File , '                                 ('Space(Kopy_Line)')'
   Call LineOut Syslevel_List_File

   ver '/R >> 'Syslevel_List_File
   Call LineOut Syslevel_List_File , Mark_Line ; Call LineOut Syslevel_List_File , ' '
   Do A = 1 to Syslevel_Check_file_Number 
      Syslevel_Check_File = 'C:\'||Syslevel_Check_file.A ; Call 8_2_1_Syslevel_List_Query
      If File_Line <> ' ' then Call LineOut Syslevel_List_File , ' '||File_Line
      If File_Line = ' '  then Call LineOut Syslevel_List_File , '  '||Syslevel_Check_File||'      -->      not found !'
   End A
   Call LineOut Syslevel_List_File , Mark_Line ; Call LineOut Syslevel_List_File , ' ' ; Call LineOut Syslevel_List_File , ' '
   Call LineOut Syslevel_List_File 
   syslevel '>> 'Syslevel_List_File

Return

/**************************************/
8_2_1_Syslevel_List_Query:
/**************************************/

   File_Line = ' '
   Call SysFileTree Syslevel_Check_File , 'file', 'FS'
      Do I = 1 to file.0
         parse value file.I with File_Date File_Time File_Size . File_Name
         Files = Left(File_Name,40) 
         
         D1 = POS('/' , File_Date) ; Date2 = SUBSTR(File_Date ,1, D1-1) ; IF Length(Date2) = 1 then Date2 = "0"||Date2
         Date1 = SUBSTR(File_Date , D1 + 1 , 2) ; Date3 = SUBSTR(File_Date , D1 + 4 , 2)
         Dates = Left(Date1||'.'||Date2||'.'||Date3 , 12)
         
         Length_Time = Length(File_Time) ; T1 = SUBSTR(File_Time , Length_Time)
         T2 = POS(':' , File_Time) ; Time1 = SUBSTR(File_Time , 1 , T2 - 1) ; IF Length_Time = 5 then Time1 = ' '||Time1
         IF T1 = 'p' then Time1 = Time1 + 12
         Time2 = SUBSTR(File_Time , T2 + 1 , 2) ; Times = Left(Time1||'.'||Time2 , 7)

         Length_Size = Length(File_Size) ; Sizes = Left(Copies(' ',10-Length_Size)||File_Size , 15)
         File_Line = Files||Sizes||Dates||Times
      End I

Return

/**************************************/
9_Open_Window_Check:
/**************************************/

   Name = Right(Search_Sub,6) ; Call SysCurPos 24,2 ; say
   ren Search_Sub||' '||Name

Return

/**************************************/
10_1_ERROR_HANDLING:
/**************************************/

   ERROR_CODE = 0
   Do Line = 1 to 25
      Text_Line = SysTextScreenRead(Line,0,50) ; ERROR_CODE_0 = Left(Text_Line,7)
      If Text_Line = 'The external process was cancelled by a Ctrl+Break' then Call 10_2_BREAK_HANDLING
      If Left(ERROR_CODE_0, 3) = 'SYS' then 
         Do
            ERROR_CODE = Right(ERROR_CODE_0,4) ; ERROR_LINE = Line
         End
   End Line

   If ERROR_CODE = '0002' then
      Do
         Call SysCurPos ERROR_LINE , 0 ; say Space_Line
         Error_Message = SysGetMessage(ERROR_CODE , OSO001.msg)
         say Error_Message || "         >>" File "<<" ; say ; say
         Return
      End
   If ERROR_CODE <> 0 then
      Do
         Call SysCurPos ERROR_LINE , 0 ; say Space_Line
         say ' >>>  The programm was stopped !  <<<' ; say
         Error_Message = SysGetMessage(ERROR_CODE , OSO001.msg)
         say Error_Message
         Error_Help = SysGetMessage(ERROR_CODE , OSO001H.msg)
         say ; say Error_Help
      End
    If ERROR_CODE = 0 then 
       Do
          ERROR_Bit = true ; Return
       End
exit

/**************************************/
10_2_BREAK_HANDLING:
/**************************************/

   say ; say ; say; say
   say ' >>>  The programm was stopped !  <<<' ; say
   say 'The external process was cancelled by a Ctrl+Break or another process'

exit
