@REM --------------------------------------------------------------------------------
@REM       Filename:     AmuStart.cmd
@REM       Description:  Start Script for the AMU modules
@REM
@REM     [cd can
@REM      DL                                     Download binaries to CAN-controller
@REM      cd ..]
@REM     start /C /min "AMU Kernel" krn [/S] [/R] [/B]
@REM                              Options: /S    AMU with a DAS
@REM                                       /R    Dual AMU (AMU router is running)
@REM                                       /B    Dual AMU (AMU Backup Deamon is running)
@REM     [start /C /min "AMU Router" rte]        Dual-AMU with router
@REM     [start /C /min "AMU Backup Deamon" bud] Dual-AMU with Backup Deamon
@REM     start con [/L]           Option:  /L automatic start of Online Log
@REM --------------------------------------------------------------------------------

cd can
DL
cd ..

start /C /min "AMU Kernel" krn /S /R /B
start /C /min "AMU Router" rte
start /C /min "AMU Backup Deamon" bud
start con /L
exit



